{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,16384,655360}
Program TextDemo;

  { example usage of TTextViewer
    displays itself (ie. textdemo.pas which must be
    in the current dir).
  }

uses Drivers, Objects, Memory, Views, Dialogs, Menus, App, MsgBox,TTextV;


const cmTestFramed = 9998;
      cmTestFull =   9999;

type
  TDemoApp = object(TApplication)
                  constructor Init;
                  procedure InitMenuBar;                    virtual;
                  procedure InitStatusLine;                 virtual;
                  procedure HandleEvent(var Event: TEvent); virtual;
                  Procedure Test(Full: boolean);
  end;

constructor TDemoApp.Init;
begin
  inherited Init;
end;


Procedure TDemoApp.Test(Full: boolean);
var
  Viewer:          PTextViewer;
  TextViewFile,
  DemoFile:        text;
  TextViewStyle:   word;
  r:               trect;
  s:               string;

begin
  s := '';
  r.assign(0,0,80,ScreenHeight - 2);
  if Full then TextViewStyle := TextViewFull or ttvHideVScroll or ttvHideHScroll
  else
   begin
     s := ^C'Some static text displayed above the text window.'+
          ^M^C'if you take it out the text window grows upwards.';
     TextViewStyle := TextViewNormal;
   end;

  new(Viewer,Init(r,TextViewStyle,'',s,TextViewFile));
  if Viewer = nil then exit;
  Viewer^.SetState(sfShadow,False);
  Viewer^.GrowMode := gfGrowAll;
  Viewer^.HelPCtx := hcTextViewer;


  assign(DemoFile,'textdemo.pas');  { read this source as demo }
  reset(DemoFile);
  repeat
    readln(DemoFile,s);
    writeln(TextViewFile,s);
  until eof(DemoFile);

  Viewer^.Terminal^.Gotoxy(1,1);        { put cursor at top }
  Viewer^.Terminal^.ScrollTo(0,0);      { Set display to top line }
  Viewer^.SetState(sfVisible,true);     { Show the view (inits self hidden) }
  Desktop^.ExecView(Viewer);

  { Example, read back lines tagged by the user }
  s := Viewer^.FirstTaggedLine;
  repeat
    s := Viewer^.NextTaggedLine;
  until s = '';
  dispose(Viewer,done);

  { The above demo uses a modal view but of course you can use a non-modal
    TTextView with DeskTop^.Insert(Viewer) rather than ExecView;
  }
End;


procedure TDemoApp.HandleEvent(var Event: TEvent);

begin
  inherited HandleEvent(Event);
  case Event.What of
       evCommand:
           case Event.Command of
                cmTestFramed: Test(False);
                cmTestFull:   Test(True);
                else begin
                       MessageBox('A Handler for this event has not'^M'yet been installed!!!',
                                   Nil,
                                   mfWarning or mfOkButton);
                       Exit;
                     end;
           end;{ case Event.Command}


       {evBroadcast: case event.Command of
                    end;}


  end; { case Event.What }
  ClearEvent(Event);
end;

procedure TDemoApp.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar,Init(R,Newmenu(
                 NewSubMenu('~F~ile',hcNoContext,
                   NewMenu(
                     NewItem('e~X~it','',0,cmQuit,hcNoContext,
                     NewItem('Framed Text View','',0,cmTestFramed,hcNoContext,
                     NewItem('Fullscreen Text View','',0,cmTestFull,hcNoContext,
                              Nil)))
                     ),
                   nil))
              ));
end;

procedure TDemoApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, hcTextViewer-1,
      NewStatusKey('~F2~ Framed Text View', kbF2, cmTestFramed,
      NewStatusKey('~F3~ Fullscreen Text View', kbF3, cmTestFull,
      StdStatusKeys(nil))),

    NewStatusDef(hcTextViewer, $FFFF,
      NewStatusKey('~F3~ Search', kbF3, cmSearch,
      NewStatusKey('~F4~ Again', kbF4, cmAgain,
      StdStatusKeys(nil))),
    nil))));
end;

var
  DemoApp: TDemoApp;

begin
  DemoApp.Init;
  DemoApp.Run;
  DemoApp.Done;
end.

